<?php
/*
 * Frontend editor, including title/content
 */

function input_after_check_set($fields,$str){
	global $post;
	$checkstatus = '';
	if(get_post_meta($post->ID,$fields,true)=='on')$checkstatus = 'checked';
	$aftercheck = '<span class="setcheck right"><input type="checkbox" class="afterCheck" id="bargain" '.$checkstatus.'><label for="bargain"></label><span class="bargain-desc">'.$str.'</span></span>';
	return $aftercheck;
}

function cmb_only_show_for_user_admin( $display, $meta_box ) {
	if ( ! isset( $meta_box['show_on']['key'], $meta_box['show_on']['value'] ) ) {
		return $display;
	}

	if ( 'user-type' !== $meta_box['show_on']['key'] ) {
		return $display;
	}

	return current_user_can( $meta_box['show_on']['value'] );
}
add_filter( 'cmb2_show_on', 'cmb_only_show_for_user_admin', 10, 2 );
 
function chumi_frontend_edit_form_register() {

	function default_title_set(){//问答部分
		if(isset($_GET['reply'])){
			$title = get_post($_GET['id'])->post_title.'-'.wp_get_current_user()->nickname.'的回答';
		} else {
			$title = get_post($_GET['id'])->post_title;
		}
		return $title;
	}	

	$cmb = new_cmb2_box( array(
		'id'           => 'front-end-post-edit-form',
		'object_types' => array( 'post' ),
		'hookup'       => false,
		'cmb_styles' => false,
		'save_fields'  => false,
	) );	


	// and prepend title
	$cmb->add_field( array(
		'name'   => __( 'Title', 'cmb2' ),
		'id'     => 'post_title',
		'type'    => 'text',		
		'show_names' => false,
		'attributes' => array(
			'autocomplete' => 'off', 
			'class'=>'required',
			'placeholder'=>'在此输入标题',
		),			
		//'before' => 'jt_edit_core_maybe_redirect',
	) );

	// and content fields
	$cmb->add_field( array(
		'name'  => __( 'Content', 'cmb2' ),
		'id'    => 'post_content',
		'show_names' => false,
		'type'    => 'wysiwyg', 
		'attributes' => array(
		'class'=>'required',
		),		
		'options' => array(
			'media_buttons' => true, 
			'teeny' => true,
			'tinymce' => true, 
			'class'=>'required',
			'textarea_rows' => 25, 
			'quicktags' => false 
		),
	) );
		
	$cmb->add_field( array( //分类模块
		'name'    =>  __( '选择分类', 'cmb2' ),
		'id'      => 'submitted_post_cat',
		'type'    => 'terms_rdo_inline', //该函数定义在最前面
	) );
	
	$cmb->add_field( array(
		'name'    =>  __( '设置封面图片', 'cmb2' ),
		'id'      => 'post_thumbnail',
		'type'    => 'file',
		'query_args' => array(
			'type' => array('image/jpeg','image/gif','image/png','image/bmp'),
		),	
		'options' => array(
			'url' => false, // Hide the text input for the url
		),
	) );	
	
	$cmb->add_field( array( //标签
		'name'    =>  __( '添加关键词' ),
		'id'      => 'submitted_post_tag',
		'type'    => 'text',
		'attributes'  => array(		
			'autocomplete' => 'off',
		),			
	) ); 	
 	
	$cmb->add_field( array( //站外链接
		'name' => __( '选择或注明文章版权信息', 'cmb2' ),
		'id'   => 'copyright',
		'type' => 'copyright',//定义在文档开头
	) );

	$cmb->add_field( array( 
		'id'      => 'zhuanzai',
		'type'    => 'text',
		'show_names' => false,
		'attributes'  => array(		
			'autocomplete' => 'off',
			'class'=>'required',
			'placeholder'=>'输入来源名称……',
			'showon'=>'w',
		),		
	) );
	$cmb->add_field( array( 
		'id'      => 'wangzhi',
		'type'    => 'text_link',
		'show_names' => false,
		'attributes'  => array(		
			'autocomplete' => 'off',
			'class'=>'required',
			'placeholder'=>'网址前请加上http://',
			'showon'=>'w',
			
		),	
	) );
	
	$cmb->add_field( array( 
		'id'      => 'qikan',
		'type'    => 'text_medium',
		'show_names' => false,
		'attributes'  => array(		
			'autocomplete' => 'off',
			'class'=>'required',
			'placeholder'=>'输入期刊名称、期数等……',
			'showon'=>'k',//js控制
			
		),	
	) );	
	
	$cmb->add_field( array( 
		'id'      => 'page_script_fake',
		'type'    => 'post_script', 
	) );
	
//video 字段

	$cmb = new_cmb2_box( array(
		'id'           => 'front-end-video-edit-form',
		'object_types' => array( 'video' ),
		'hookup'       => false,
		'cmb_styles' => false,
		'save_fields'  => false,
	) );

		$cmb->add_field( array(
			'name'    => __( '选择上传或转载视频', 'cmb2' ),
			'id'      => 'video_sharemode',
			'type'    => 'video_sharemode',
		) );	

		$cmb->add_field( array(
			'id'      => 'video',
			'type'    => 'file',
			'query_args' => array(
				'type' => 'video/mp4 ', // Make library only display PDFs.
			),
			'before_field' =>input_after_check_set('add_gifplayer','启用Gif播放器(启用后将不播放视频中的声音)'),
			'attributes'  => array(		
				'autocomplete' => 'off',
				'showon'=>'video_upload',
			),				
		) );

		$cmb->add_field( array(
			'id'   => 'add_gifplayer',
			'type' => 'hidden',			
		) );
		
		$cmb->add_field( array(
			'id'      => 'videouri',
			'type'    => 'text_link',
			'attributes'  => array(		
				'autocomplete' => 'off',
				'class'=>'required',
				'showon'=>'video_reprint',
				'placeholder'=>'网址前请加上http://',				
			),				
		) );

		$cmb->add_field( array(
			'id'      => 'wechat_videouri',
			'type'    => 'text_link',
			'attributes'  => array(		
				'autocomplete' => 'off',
				'class'=>'required',
				'showon'=>'wechat_video_reprint',
				'placeholder'=>'网址前请加上http://',				
			),				
		) );	
		
		$cmb->add_field( array(
			'id'     => 'bilibili_aid',
			'type'    => 'text_number',
			'before' => '视频源ID  ',
			'show_on' => array( 'key' => 'user-type', 'value' => 'manage_options' ), 
			'attributes' => array(
				'autocomplete' => 'off', 
				'showon'=>'video_reprint',
				'placeholder'=>'sid/vid/aid……',
			),			
		) );		

		$cmb->add_field( array(
			'id'     => 'bilibili_cid',
			'type'    => 'text_number',
			'before' => '视频源辅助ID  ',
			'show_on' => array( 'key' => 'user-type', 'value' => 'manage_options' ),
			'attributes' => array(
				'autocomplete' => 'off', 
				'showon'=>'video_reprint',
				'placeholder'=>'cid……',
			),			
		) );		
		
		// and prepend title
		$cmb->add_field( array(
			'name'   => __( '视频标题', 'cmb2' ),
			'id'     => 'post_title',
			'type'    => 'text',
			'attributes' => array(
				'autocomplete' => 'off', 
				'class'=>'required',
				'placeholder'=>'在此输入视频标题……',
			),			
			//'before' => 'jt_edit_core_maybe_redirect',
		) );

		// and content fields
		$cmb->add_field( array(
			'name'  => __( '视频简介', 'cmb2' ),
			'id'    => 'post_content',
			'type'    => 'textarea', 
			'attributes' => array(
				'id'=>'submitted_post_content',
				'rows' => 3, 
			),		
		) );		
	
	$cmb->add_field( array( //标签
		'name'    =>  __( '添加标签' ),
		'id'      => 'submitted_post_tag',
		'type'    => 'text',
		'attributes'  => array(		
		'autocomplete' => 'off',
		),			
	) ); 	
 	
	$cmb->add_field( array( //站外链接
		'name' => __( '选择或注明版权信息', 'cmb2' ),
		'id'   => 'copyright',
		'type' => 'copyright',//定义在文档开头
	) );

	$cmb->add_field( array( 
		'id'      => 'zhuanzai',
		'type'    => 'text',
		'show_names' => false,
		'attributes'  => array(		
			'autocomplete' => 'off',
			'class'=>'required',
			'placeholder'=>'输入来源名称……',
			'showon'=>'w',
		),		
	) );
	$cmb->add_field( array( 
		'id'      => 'wangzhi',
		'type'    => 'text_link',
		'show_names' => false,
		'attributes'  => array(		
			'autocomplete' => 'off',
			'class'=>'required',
			'placeholder'=>'网址前请加上http://',
			'showon'=>'w',
			
		),	
	) );
	
	$cmb->add_field( array( 
		'id'      => 'qikan',
		'type'    => 'text_medium',
		'show_names' => false,
		'attributes'  => array(		
			'autocomplete' => 'off',
			'class'=>'required',
			'placeholder'=>'输入期刊名称、期数等……',
			'showon'=>'k',//js控制
			
		),	
	) );
	
	$cmb->add_field( array( 
		'id'      => 'page_script_fake',
		'type'    => 'video_script', 
	) );
	
//video字段(二级设置)

	$cmb = new_cmb2_box( array(
		'id'           => 'front-end-video-high-edit-form',
		'object_types' => array( 'video' ),
		'hookup'       => false,
		'cmb_styles' => false,
		'save_fields'  => false,
	) );
		
		$cmb->add_field( array( 
			'name'    =>  __( '为视频选择一个最恰当的类别', 'cmb2' ),
			'id'      => 'submitted_post_cat',
			'type'    => 'topic_mode', 
		) );		

		$cmb->add_field( array(
			'name'    =>  __( '设置封面图片', 'cmb2' ),
			'id'      => 'video_thumbnail',
			'type'    => 'file',
			'query_args' => array(
				'type' => array('image/jpeg','image/gif','image/png','image/bmp'),
			),	
			'options' => array(
				'url' => false, // Hide the text input for the url
			),
		) );
		
		$cmb->add_field( array( 
			'id'      => 'page_script_fake',
			'type'    => 'video_script', 
		) );
	

//case 字段

	$cmb = new_cmb2_box( array(
		'id'           => 'front-end-case-edit-form',
		'object_types' => array( 'case' ),
		'hookup'       => false,
		'cmb_styles' => false,
		'save_fields'  => false,
	) );
	
		// and prepend title
		$cmb->add_field( array(
			'name'   => __( '项目或案例名称', 'cmb2' ),
			'id'     => 'post_title',
			'type'    => 'text',
			'attributes' => array(
				'autocomplete' => 'off', 
				'class'=>'required',
				'placeholder'=>'在此输入项目或案例标题……',
			),
		) );	
		
		// and content fields
		$cmb->add_field( array(
			'name'  => __( '项目或案例的简要介绍', 'cmb2' ),
			'id'    => 'post_content',
			'type'    => 'textarea', 
			'attributes' => array(
				'class'=>'required',
				'id'=>'submitted_post_content',
				'rows' => 6, 
			),		
		) );	
		
		$cmb->add_field( array( // 附件上传
			'name' => __( '上传或选择案例图片(必填)', 'cmb2' ),	
			'show_names' => false,
			'id'   => 'case_images',
			'before_field' => '',//input_after_check_set('正文不显示封面图片'),
			'type' => 'file_list',
			'query_args' => array(
				'type' => array('image/jpeg','image/gif','image/png','image/bmp'),
			),			
			'options' => array(
				'url' => false, 
			),		
			'text' => array(
				'add_upload_files_text' => '上传案例图片', 
				'remove_image_text' => '移除', 
				'file_text' => '图片',
				'file_download_text' => '', 
				'remove_text' => '取消', 
			),
		) );

		$cmb->add_field( array(
			'name'  => __( '使用幻灯片展示案例图片？', 'cmb2' ),
			'id'    => 'showSlider',
			'type'    => 'multicheck_inline',
			'select_all_button' => false,
			'options' => array(
				'unshowslide' => __( '不使用', 'cmb2' ),
				'autoslide' => __( '自动播放', 'cmb2' ),
				'progressbar'   => __( '进度条', 'cmb2' ),
				'pagination'     => __( '隐藏导航', 'cmb2' ),
				'autosize'     => __( '启用自适应', 'cmb2' ),
			),
			'default' => 'unshowslide',
		) );
		
	$cmb->add_field( array(
		'id'      => 'setPoster',
		'type'    => 'hidden',
	) );

	$cmb->add_field( array(
		'id'      => 'unShowPoster',
		'type'    => 'hidden',
	) );	
	
	$cmb->add_field( array( //标签
		'name'    =>  __( '添加标签（会在用户检索标签时展示）' ),
		'id'      => 'submitted_post_tag',
		'type'    => 'text',
		'attributes'  => array(		
		'autocomplete' => 'off',
		),			
	) ); 	
	
	$cmb->add_field( array( 
		'id'      => 'page_script_fake',
		'type'    => 'case_script', 
	) );	

//case字段(二级设置)

	$cmb = new_cmb2_box( array(
		'id'           => 'front-end-case-high-edit-form',
		'object_types' => array( 'case' ),
		'hookup'       => false,
		'cmb_styles' => false,
		'save_fields'  => false,
	) );	
		
	//完成时间
	$cmb->add_field( array(
		'name' => __( '工作周期（大致耗时多长时间？）', 'cmb2' ),
		'id'   => 'case_datetime',
		'type' => 'text_small',	
		'after_field' => '&nbsp;&nbsp;天&nbsp;&nbsp;(自然天)', 		
		'attributes'  => array(	
			'onkeypress'   =>  'number()',
			'onkeyup'   =>  'filterInput()',
			'onchange'   =>  'filterInput()',
			'onbeforepaste'   =>  'filterPaste()',
			'onpaste'   =>  'return false',
			'style'   =>  'ime-mode: disabled',			
			'autocomplete' => 'off',
			'maxlength' => '3',
			'placeholder'=>'输入完成周期……',
			'class'=>'required',
		),
	) );	
	
	//计划金额
	$cmb->add_field( array(
		'name'       => __( '参考费用（完成该项目需要的费用）', 'cmb2' ),
		'id'         => 'case_price',
		'type'       => 'text_number',	
		'after_field' => '&nbsp;&nbsp;RMB', 
		'attributes'  => array(
			'onkeypress'   =>  'number()',
			'onkeyup'   =>  'filterInput()',
			'onchange'   =>  'filterInput()',
			'onbeforepaste'   =>  'filterPaste()',
			'maxlength' => '10',
			'onpaste'   =>  'return false',
			'style'   =>  'ime-mode: disabled',	
			'autocomplete' => 'off',
			'placeholder'=>'输入金额……',
			'class'=>'required',
		),		
	) );	

	$cmb->add_field( array( 
		'name'       => __( '案例在线地址（选填）', 'cmb2' ),	
		'id'      => 'caes_wangzhi',
		'type'    => 'text_link',
		'attributes'  => array(		
			'autocomplete' => 'off',
			'placeholder'=>'网址前请加上http://',
		),	
	) );


		$cmb->add_field( array(
			'name'    => __( '选择上传或转载案例视频(选填)', 'cmb2' ),
			'id'      => 'video_sharemode',
			'type'    => 'video_sharemode2',
		) );

		$cmb->add_field( array(
			'id'      => 'video',
			'type'    => 'file',
			'query_args' => array(
				'type' => 'video/mp4 ', // Make library only display PDFs.
			),
			'attributes'  => array(		
				'autocomplete' => 'off',
				'showon'=>'video_upload',
			),				
		) );
		
		$cmb->add_field( array(
			'id'      => 'videouri',
			'type'    => 'text_link',
			'attributes'  => array(		
				'autocomplete' => 'off',
				'class'=>'required',
				'showon'=>'video_reprint',
				'placeholder'=>'网址前请加上http://',				
			),				
		) );

	$cmb->add_field( array( 
		'id'      => 'page_script_fake',
		'type'    => 'case_script', 
	) );
	
// download的字段

	$cmb = new_cmb2_box( array(
		'id'           => 'front-end-download-edit-form',
		'object_types' => array( 'download' ),
		'hookup'       => false,
		'cmb_styles' => false,
		'save_fields'  => false,
	) );	

	$cmb->add_field( array( // 标题模块
		'name'    => __( '标题', 'chumi' ),
		'id'      => 'post_title',
		'type'    => 'text',		
		'show_names' => false,
		'attributes' => array(
			'autocomplete' => 'off', 
			'class'=>'required',
			'placeholder'=>'在此输入标题（必填）……',
		),
	) );

	$cmb->add_field( array( // 内容模块
		'name'    => __( '资料列表（核心字段：如若更改请自行重新发布或联系管理员删除）', 'chumi' ),
		'id'      => 'download_list_fake',
		'type'    => 'download_list',		
	) );	

	$cmb->add_field( array( // 内容模块
		'name'    => __( '简单介绍您上传的资料(必填)', 'chumi' ),
		'id'      => 'post_content',
		'type'    => 'wysiwyg', 
		'attributes' => array(
			'class'=>'required',
		),		
		'options' => array(
			'media_buttons' => false, 
			'teeny' => true,
			'tinymce' => true, 
			'class'=>'required',
			'textarea_rows' => 12, 
			'quicktags' => false 
		),	
	) );		
	
	$cmb->add_field( array( //标签
		'name'    =>  __( '添加资料标签（方便在关联内容上展示）' ),
		'id'      => 'submitted_post_tag',
		'type'    => 'text',
		'attributes'  => array(		
			'autocomplete' => 'off',
		),			
	) ); 	
	
	$cmb->add_field( array( 
		'id'      => 'page_script_fake',
		'type'    => 'download_script', 
	) );

//for topic
	$cmb_topicreply = new_cmb2_box( array(
		'id'           => 'front-end-topic-edit-form',
		'object_types' => array('topic'),
		'hookup'       => false,
		'cmb_styles' => false,		
		'save_fields'  => false,
	) );
	
	$cmb_topicreply->add_field( array( 
		'id'      => 'page_script_fake',
		'type'    => 'topicreply_script', 
	) );	
	
	$cmb_topicreply->add_field( array( // 标题模块
		'name'    => __( '标题', 'chumi' ),
		'id'      => 'post_title',
		'type'    => 'text',		
		'show_names' => false,
		'attributes' => array(
			'autocomplete' => 'off', 
			'class'=>'required',
			'placeholder'=>'请在此输入帖子标题',
		),
	) ); 	
	
	$cmb_topicreply->add_field( array( //标签
		'name'    =>  __( '在下方按粘贴保存在<b>新浪相册</b>上的图片网址（使用Ctrl+v快捷键，最多支持5个url地址）。不了解如何贴图？按此<a class="helplink" href="">查看教程</a>' ),
		'id'      => 'topic_imgurls',
		'type'    => 'text_link',
		'repeatable' => true,
		'options'     => array(
			'limit'         => 4
		),
		'classes' => 'topic-url-input',
		'attributes'  => array(		
			'autocomplete' => 'off',
			'class'=>'required',
		),			
	) );	
	
  	$cmb_topicreply->add_field( array( // 标题模块
		'name'    => __( '内容描述', 'chumi' ),
		'id'      => 'topic_content',
		'type'    => 'textarea',
		'show_names' => false,
		'attributes' => array(
			'autocomplete' => 'off',
			'rows' => 3,
			'placeholder'=>'请在此输入简要内容描述(非必填，120字内)',
		),
	) );
	
	$cmb_topicreply->add_field( array( 
		'name'    =>  __( '为帖子选择一个最恰当的类别', 'cmb2' ),
		'id'      => 'submitted_post_cat',
		'type'    => 'topic_mode', 
	) );
	
	$cmb_topicreply->add_field( array( //标签
		'name'    =>  __( '帖子标签' ),
		'id'      => 'submitted_post_tag',
		'type'    => 'text',
		'attributes'  => array(		
		'autocomplete' => 'off',
		),			
	) );
}

add_action( 'cmb2_init', 'chumi_frontend_edit_form_register' ); 

function jt_add_edit_form_to_frontend( $content ) {
		
	$already = get_post_meta(get_the_ID(),'reply_already',true);
	$cur_userid = get_current_user_id(); 																	
	$reply_id = $already[$cur_userid];
	$cpt = get_post($reply_id)->post_type;	
	
	if ( isset( $_GET['edit'] ) && current_user_can('edit_posts') ) {
		if (is_singular( 'download') && wp_verify_nonce( $_GET['edit'], 'edit' ) ) {//下载
			$content = cmb2_get_metabox_form( 'front-end-download-edit-form', get_the_ID(),array( 'save_button' => __( '提交审核', 'chumi' ) ) );
		} elseif (is_singular( 'post') && wp_verify_nonce( $_GET['edit'], 'edit' )) {//文章
			$content = cmb2_get_metabox_form( 'front-end-post-edit-form', get_the_ID(),array( 'save_button' => __( '提交审核', 'chumi' ) ) );
		} elseif (is_singular( 'topic') && wp_verify_nonce( $_GET['edit'], 'edit' )) {//topic
			$content = cmb2_get_metabox_form( 'front-end-topic-edit-form', get_the_ID(),array( 'save_button' => __( '提交修改', 'chumi' ) ) );
		} elseif (is_singular( 'video') && wp_verify_nonce( $_GET['edit'], 'edit' )&& !isset($_GET['step'])) {//视频
			$content = cmb2_get_metabox_form( 'front-end-video-edit-form', get_the_ID(),array( 'save_button' => __( '提交审核', 'chumi' ) ) );
		} elseif (is_singular( 'video') && $_GET['step']=='2' && wp_verify_nonce( $_GET['edit'], 'edit' )) {//视频2
			$content = cmb2_get_metabox_form( 'front-end-video-high-edit-form', get_the_ID(),array( 'save_button' => __( '提交审核', 'chumi' ) ) );	
		} elseif (is_singular( 'case') && wp_verify_nonce( $_GET['edit'], 'edit' )&& !isset($_GET['step'])) {//案例
			$content = cmb2_get_metabox_form( 'front-end-case-edit-form', get_the_ID(),array( 'save_button' => __( '提交审核', 'chumi' ) ) );		
		} elseif (is_singular( 'case') && $_GET['step']=='2' && wp_verify_nonce( $_GET['edit'], 'edit' )) {//案例2
			$content = cmb2_get_metabox_form( 'front-end-case-high-edit-form', get_the_ID(),array( 'save_button' => __( '提交审核', 'chumi' ) ) );		
		} else {
			$content = '<h2 class="edit-error">原来你也在这里，可这儿什么都没有</h2>';
		}

	}
	
	if ( isset($_GET['fb']) && current_user_can('edit_posts') ) {
		if ( is_singular('topic') && wp_verify_nonce($_GET['fb'],'fb') && ($_GET['action']=='new'||$_GET['action']=='child')) {
			$content = cmb2_get_metabox_form('front-end-topic-edit-form', 'fake-id',array( 'save_button' => __('好了，装一发','chumi')) );	
		} else {
			wp_redirect(get_permalink(get_the_ID()));
		}
	}
	return $content;
}
add_filter( 'the_excerpt', 'jt_add_edit_form_to_frontend' );

/**
 * Modify the edit links to point to the front-end editor.
 */
function jt_modify_edit_link( $link ) {	
	$cpt = get_post(get_the_ID())->post_type;
 	if ( !is_admin() &&( $cpt == 'topic' || $cpt == 'post' || $cpt == 'video'|| $cpt == 'case' ) )
		$link = esc_url_raw( wp_nonce_url( get_permalink(get_the_ID()), 'edit', 'edit' ) ).'&action='.get_the_ID();
	return $link;
}
add_filter( 'get_edit_post_link', 'jt_modify_edit_link' );

function fb_singular_link($action,$tid) {
	if(empty($tid))
		$tid = get_the_ID();
	$cpt = get_post($tid)->post_type;
 	if ( !is_admin() && $cpt == 'topic' ) { 
		$link = esc_url_raw( wp_nonce_url( get_permalink($tid), 'fb', 'fb' ) ).'&action='.$action;
	}
	return $link; 
}

/**
 * Modify the ueser edit links to point to the front-end editor.
 */
function jt_user_edit_link( $link ) {		
	if(!is_admin()){
		$link = esc_url_raw( wp_nonce_url( home_url('/user/account'), 'edit', 'edit' ) );
		return $link;
	}
}
add_filter( 'get_edit_user_link', 'jt_user_edit_link' );

/**
 * We don't want CMB2 to fetch data from meta for post title and post content
 */
function jt_cmb2_override_core_field_get( $val, $object_id, $a, $field ) {

	global $post;
	
	if(!isset($_GET['fb'])) {
		if ( in_array( $field->id(), array( 'post_title', 'post_content' ), true ) ) {
			if ( isset( $post->ID ) ) {
				$val = get_post_field( $field->id(), $post );
			} else {
				$val = '';
			}
		}
	}

	return $val;
}
add_filter( 'cmb2_override_meta_value', 'jt_cmb2_override_core_field_get', 10, 4 );


/**
 * Handles form submission on save. Redirects if save is successful, otherwise sets an error message as a cmb property
 * @return void
 */
function chumi_handle_frontend_edit_post() {

	if ( empty( $_POST ) || ! isset( $_POST['submit-cmb'], $_POST['object_id'] ) ) {
		return false;
	}
	$metabox_id = 'front-end-post-edit-form';	
	$current_url = home_url(add_query_arg(array()));	
	$object_id  = substr($current_url,strpos($current_url,'_')+1,strpos($current_url,'.html')-strpos($current_url,'_')-1);

	$cmb = cmb2_get_metabox( $metabox_id, $object_id);

	$post_data = array();

	if ( ! isset( $_POST[ $cmb->nonce() ] ) || ! wp_verify_nonce( $_POST[ $cmb->nonce() ], $cmb->nonce() ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'security_fail', __( '未能通过安全检查！' ) ) );
	}

	if ( empty( $_POST['post_title'] ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '请在标题框中输入标题！' ) ) );
	}
	
	if ( empty( $_POST['post_content'] ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '请填写文章内容后再提交' ) ) );
	}		

	if ( $cmb->get_field( 'post_title' )->default() == $_POST['post_title'] ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '重复！请输入一个新标题。' ) ) );
	}		

	$sanitized_values = $cmb->get_sanitized_values( $_POST );

	$post_data['post_title']   = $sanitized_values['post_title'];
	unset( $sanitized_values['post_title'] );
	$post_data['post_content'] = $sanitized_values['post_content'];
	unset( $sanitized_values['post_content'] );	
	$post_data['tags_input'] = $sanitized_values['submitted_post_tag'];
	unset( $sanitized_values['submitted_post_tag'] );
	$post_data['post_parent'] = $sanitized_values['parent'];	
	unset( $sanitized_values['parent'] );
		
	$cat = $sanitized_values['submitted_post_cat'];	
	unset( $sanitized_values['submitted_post_cat'] );

	$category = get_term_by( 'id',$cat,'category')->name;
	if(empty($category)){$category = get_the_category($object_id)[0]->cat_name;}		
	
	wp_set_object_terms( $object_id, $category, 'category');

	wp_update_post( array( 
		'ID' => $object_id,
		'post_title'=> $post_data['post_title'],
		'post_content'=>$post_data['post_content'],
		'tags_input'=>$post_data['tags_input'],
		'post_parent'=>$post_data['post_parent'],
		'_thumbnail_id' => $sanitized_values['post_thumbnail_id'],
		'post_status' => 'pending',
	) );

	if ( is_wp_error( $object_id ) ) {
		return $cmb->prop( 'submission_error', $object_id );
	}
		
	unset( $post_data['post_type'] );
	unset( $post_data['post_status'] );

	foreach ( $sanitized_values as $key => $value ) {
		if ( is_array( $value ) ) {
			$value = array_filter( $value );
			if( ! empty( $value ) ) {
				update_post_meta( $object_id, $key, $value );
			}
		} else {
			update_post_meta( $object_id, $key, $value );
		}
	}	
	
	wp_redirect(esc_url_raw( remove_query_arg( array('edit','action','type'))));
	exit;	

}
add_action( 'cmb2_after_init', 'chumi_handle_frontend_edit_post' );

//处理视频
function chumi_handle_frontend_edit_video() {
	
	if ( empty( $_POST ) || ! isset( $_POST['submit-cmb'], $_POST['object_id'] ) ) {
		return false;
	}	

	$metabox_id = 'front-end-video-edit-form';
	$current_url = home_url(add_query_arg(array()));	
	$object_id  = substr($current_url,strpos($current_url,'_')+1,strpos($current_url,'.html')-strpos($current_url,'_')-1);

	$cmb = cmb2_get_metabox( $metabox_id, $object_id );

	$post_data = array();

	if ( ! isset( $_POST[ $cmb->nonce() ] ) || ! wp_verify_nonce( $_POST[ $cmb->nonce() ], $cmb->nonce() ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'security_fail', __( '未能通过安全检查！' ) ) );
	}

	if ( empty( $_POST['post_title'] ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '请在标题框中输入标题！' ) ) );
	}
	
	if ( empty( $_POST['fake_video'] ) && empty($_POST['video_id']) && empty($_POST['wechat_videouri']) && empty($_POST['videouri']) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '请添加视频连接或文件！' ) ) );
	}

	if ( $cmb->get_field( 'post_title' )->default() == $_POST['post_title'] ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '重复！请输入一个新标题。' ) ) );
	}		

	$sanitized_values = $cmb->get_sanitized_values( $_POST );

	$post_data['post_title'] = $sanitized_values['post_title'];
	unset( $sanitized_values['post_title'] );
	$post_data['post_content'] = $sanitized_values['post_content'];
	unset( $sanitized_values['post_content'] );	
	$post_data['tags_input'] = $sanitized_values['submitted_post_tag'];
	unset( $sanitized_values['submitted_post_tag'] );

	wp_update_post( array( 
		'ID' => $object_id,
		'post_title'=> $post_data['post_title'],
		'post_content'=>$post_data['post_content'],
		'tags_input'=>$post_data['tags_input'],
		'_thumbnail_id'=> get_post_meta($sanitized_values['video_id'],'_thumbnail_id',true),
		'post_status' => 'pending',
	) );
	
	$aid_url=$sanitized_values['videouri'];
	if(strpos($aid_url,'bilibili.com') > 0 || strpos($aid_url,'hdslb.com') > 0 ) {
		if(strpos($aid_url,'av') > 0 && strpos($aid_url,'?') > 0) $aid = substr($aid_url,strpos($aid_url,'av')+2,strpos($aid_url,'?')-strpos($aid_url,'av')-3);
		if(strpos($aid_url,'av') > 0 &&  strpos($aid_url,"?") < 1) {$aid = substr($aid_url,strpos($aid_url,"av")+2);$aid = substr($aid,0,strpos($aid,"/"));}
		if(strpos($aid_url,'aid') > 0) $aid = substr($aid_url,strpos($aid,"aid")+3);
		
		update_post_meta( $object_id, 'bilibili_aid', $aid );
	}
	
	$vid_url=$sanitized_values['wechat_videouri'];
	if(strpos($vid_url,'qq.com') > 0 && strpos($vid_url,'html') > 0) {
		$vid=substr($vid_url,strpos($vid_url,'html')-12,11);	
		update_post_meta( $object_id, 'qq_vid', $vid );
	}

	if ( is_wp_error( $object_id ) ) {
		return $cmb->prop( 'submission_error', $object_id );
	}

	foreach ( $sanitized_values as $key => $value ) {
		if ( is_array( $value ) ) {
			$value = array_filter( $value );
			if( ! empty( $value ) ) {
				update_post_meta( $object_id, $key, $value );
			}
		} else {
			update_post_meta( $object_id, $key, $value );
		}
	}	

	/**
	 * 将附件附加到新生成的文章ID里
	 */	
	
    if ( !is_admin() ){
		
        $user_id = wp_get_current_user()->ID;
		$thumb_id = get_post_meta($object_id,'_thumbnail_id',true);//父级封面
		
        if( get_post_type( $object_id ) == 'video' && $user_id ){ // set 'post', 'page', or your custom posttype

			$file_id = $sanitized_values['video_id'];	
			$author = get_post($file_id)->post_author;//作者
			$file_parent = get_post($file_id)->post_parent;//父级
				
                if (( $author == $user_id && $file_parent == 0)||$file_parent == $object_id){//若本就是父级则无需确认作者
                    $at_post = array();
                    $at_post['ID'] = $file_id;
					$at_post['post_title'] = $post_data['post_title'];//与父级标题一致
					$at_post['_thumbnail_id'] = $thumb_id;//与父级封面一致
                    $at_post['post_parent'] = $object_id; // set post_parent
                    wp_update_post( $at_post );
                }

        }
    }
	
	$videoid = get_post_meta($new_video_id,'video_id',true);//挂载的视频id
	if(!empty($videoid) ){
		$thumbnail_id = get_post_thumbnail_id( $videoid );
		wp_update_post( array( 
			'ID' => $videoid,
			'post_title'=> $post_data['post_title'],
		) );
		update_post_meta( $new_video_id, 'video_thumbnail_id', $thumbnail_id );
		update_post_meta( $new_video_id, 'video_thumbnail', wp_get_attachment_image_src( $thumbnail_id,full)[0] );

		if(has_post_thumbnail($new_video_id) == false)
			wp_update_post( array('ID' =>  $new_video_id,'_thumbnail_id' => $thumbnail_id) );
	}
	
	wp_redirect(esc_url_raw( remove_query_arg( array('edit','action','type'))));
	exit;	

}
add_action( 'cmb2_after_init', 'chumi_handle_frontend_edit_video' );

//处理视频二级设置
function chumi_handle_frontend_high_edit_video() {

	if ( empty( $_POST ) || ! isset( $_POST['submit-cmb'], $_POST['object_id'] ) ) {
		return false;
	}
	$metabox_id = 'front-end-video-high-edit-form';	
	$current_url = home_url(add_query_arg(array()));	
	$object_id  = substr($current_url,strpos($current_url,'_')+1,strpos($current_url,'.html')-strpos($current_url,'_')-1);

	$cmb = cmb2_get_metabox( $metabox_id, $object_id );

	$post_data = array();

	if ( ! isset( $_POST[ $cmb->nonce() ] ) || ! wp_verify_nonce( $_POST[ $cmb->nonce() ], $cmb->nonce() ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'security_fail', __( '未能通过安全检查！' ) ) );
	}

	$sanitized_values = $cmb->get_sanitized_values( $_POST );
	
	$_POST['video_thumbnail_id'] = $sanitized_values['video_thumbnail_id'];
	if(empty($_POST['video_thumbnail_id'])) $_POST['video_thumbnail_id'] = get_post_thumbnail_id($object_id);

	$cat = $sanitized_values['submitted_post_cat'];	
	unset( $sanitized_values['submitted_post_cat'] );
	$category = intval($cat);
	$exist_cats = get_the_terms($object_id,'topic-types');
	if(empty($category)) {
		$category = get_term_by('slug','t-2','topic-types')->term_id;//new:t-2 default
		if(!empty($exist_cats[0]))$category = $exist_cats[0]->term_id;//edit:max 1 cat

	}
	
	wp_set_object_terms( $object_id, $category, 'topic-types');
	wp_update_post( array(
		'ID' => $object_id,
		'_thumbnail_id' => $_POST['video_thumbnail_id'],
		'post_status' => 'pending',		
	) );
	
	unset( $post_data['post_type'] );
	unset( $post_data['post_status'] );
	
	foreach ( $sanitized_values as $key => $value ) {//实际此处未用到
		if ( is_array( $value ) ) {
			$value = array_filter( $value );
			if( ! empty( $value ) ) {
				update_post_meta( $object_id, $key, $value );
			}
		} else {
			update_post_meta( $object_id, $key, $value );
		}
	}
	
	
	/**
	 * 将附件附加到新生成的文章ID里
	 */	
	
    if ( !is_admin() ){
		
        $user_id = wp_get_current_user()->ID;
		
        if( get_post_type( $object_id ) == 'video' && $user_id ){ // set 'post', 'page', or your custom posttype

			$file_id = $_POST['video_thumbnail_id'];
			$author = get_post($file_id)->post_author;//作者
			$file_parent = get_post($file_id)->post_parent;//父级
			
			if(!has_post_thumbnail( $videoid )){ $thumb = $file_id; } else { $thumb = get_post_thumbnail_id( $videoid );}//video thumbnail image
			
			if ( $author == $user_id && $file_parent == 0){ //附件不能是已存在父id且必须和文章是同一个作者
				$at_post = array();
				$at_post['ID'] = $file_id;
				$at_post['post_title'] = get_the_title($object_id);//与父级标题一致
				$at_post['post_parent'] = $object_id; // set post_parent
				wp_update_post( $at_post );
				if(!empty($videoid)){
					wp_update_post( array( 
						'ID' => $videoid,
						'post_title'=> get_the_title($object_id),
						'_thumbnail_id'=> $thumb,
					) );
				}
			}

        }
    }	
	
	wp_redirect(esc_url_raw( remove_query_arg( array('edit','action','type','step'))));

	exit;	

}
add_action( 'cmb2_after_init', 'chumi_handle_frontend_high_edit_video');

//处理案例
function chumi_handle_frontend_edit_case() {

	if ( empty( $_POST ) || ! isset( $_POST['submit-cmb'], $_POST['object_id'] ) ) {
		return false;
	}
	$metabox_id = 'front-end-case-edit-form';	
	$current_url = home_url(add_query_arg(array()));	
	$object_id  = substr($current_url,strpos($current_url,'_')+1,strpos($current_url,'.html')-strpos($current_url,'_')-1);

	$cmb = cmb2_get_metabox( $metabox_id, $object_id );

	$post_data = array();
	
	$sanitized_values = $cmb->get_sanitized_values( $_POST );
	
	$_POST['setPoster'] = $sanitized_values['setPoster'];
	if(empty($_POST['setPoster'])) $_POST['setPoster']= get_post_thumbnail_id($object_id);
	unset( $sanitized_values['setPoster'] );	

	if ( ! isset( $_POST[ $cmb->nonce() ] ) || ! wp_verify_nonce( $_POST[ $cmb->nonce() ], $cmb->nonce() ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'security_fail', __( '未能通过安全检查！' ) ) );
	}

	if ( empty( $_POST['post_title'] ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '请在标题框中输入标题！' ) ) );
	}

	if ( empty( $_POST['setPoster'] ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '必须设置封面' ) ) );
	}
	
	if ( empty( $_POST['case_images'] ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '必须上传案例图片' ) ) );
	}	
	
	if ( empty( $_POST['post_content'] ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '请填写文章内容后再提交' ) ) );
	}		

	if ( $cmb->get_field( 'post_title' )->default() == $_POST['post_title'] ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '重复！请输入一个新标题。' ) ) );
	}

	$post_data['post_title']   = $sanitized_values['post_title'];
	unset( $sanitized_values['post_title'] );
	$post_data['post_content'] = $sanitized_values['post_content'];
	unset( $sanitized_values['post_content'] );	
	$post_data['tags_input'] = $sanitized_values['submitted_post_tag'];
	unset( $sanitized_values['submitted_post_tag'] );
		
	$cat = $sanitized_values['submitted_post_cat'];	
	unset( $sanitized_values['submitted_post_cat'] );

	$category = get_term_by( 'id',$cat,'category')->name;
	if(empty($category)){$category = get_the_category($object_id)[0]->cat_name;}		
	
	wp_set_object_terms( $object_id, $category, 'category');

	wp_update_post( array( 
		'ID' => $object_id,
		'post_title'=> $post_data['post_title'],
		'post_content'=>$post_data['post_content'],
		'tags_input'=>$post_data['tags_input'],
		'post_parent'=>$post_data['post_parent'],
		'_thumbnail_id'=> $_POST['setPoster'],
		'post_status' => 'pending',
	) );

	if ( is_wp_error( $object_id ) ) {
		return $cmb->prop( 'submission_error', $object_id );
	}
		
	unset( $post_data['post_type'] );
	unset( $post_data['post_status'] );

	foreach ( $sanitized_values as $key => $value ) {
		if ( is_array( $value ) ) {
			$value = array_filter( $value );
			if( ! empty( $value ) ) {
				update_post_meta( $object_id, $key, $value );
			}
		} else {
			update_post_meta( $object_id, $key, $value );
		}
	}
	/**
	 * 将附件附加到新生成的文章ID里
	 * our uploaded attachment post to have the same post-data
	 */	
	
    if ( !is_admin() ){
		
        $user_id = wp_get_current_user()->ID;
		$videoid = get_post_meta($object_id,'video_id',true);//父级挂载的视频id
		if(!has_post_thumbnail( $videoid )){ $thumb = get_post_thumbnail_id( $object_id ); } else { $thumb = get_post_thumbnail_id( $videoid );}//video thumbnail image
		if(!empty($videoid)){
			wp_update_post( array( 
				'ID' => $videoid,
				'post_title'=> get_the_title($object_id),
				'_thumbnail_id'=> $thumb,
			) );
		}
		
        if( get_post_type( $object_id ) == 'case' && $user_id ){

			$tempo_ids = get_post_meta($object_id, 'case_images', true);
			
            if( $tempo_ids ) : foreach ($tempo_ids as $key => $val ) : // pick attachment IDs from the customfield	
			
				$author = get_post($key)->post_author;	
				$file_parent = get_post($key)->post_parent;//父级
				
                if ( $author == $user_id && $file_parent == 0){
                    $at_post = array();
                    $at_post['ID'] = $key;
                    $at_post['post_parent'] = $object_id; 
                    wp_update_post( $at_post );
                }
				
                unset( $tempo_ids[$key] );
				
            endforeach; endif;

        }
    }	
	wp_redirect(esc_url_raw( remove_query_arg( array('edit','id','type','step'))));
	exit;	

}
add_action( 'cmb2_after_init', 'chumi_handle_frontend_edit_case');

//处理案例二级设置
function chumi_handle_frontend_high_edit_case() {

	if ( empty( $_POST ) || ! isset( $_POST['submit-cmb'], $_POST['object_id'] ) ) {
		return false;
	}
	$metabox_id = 'front-end-case-high-edit-form';	
	$current_url = home_url(add_query_arg(array()));	
	$object_id  = substr($current_url,strpos($current_url,'_')+1,strpos($current_url,'.html')-strpos($current_url,'_')-1);

	$cmb = cmb2_get_metabox( $metabox_id, $object_id );

	$post_data = array();

	if ( ! isset( $_POST[ $cmb->nonce() ] ) || ! wp_verify_nonce( $_POST[ $cmb->nonce() ], $cmb->nonce() ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'security_fail', __( '未能通过安全检查！' ) ) );
	}	

	$sanitized_values = $cmb->get_sanitized_values( $_POST );	
	
	wp_update_post( array( 
		'ID' => $object_id,
		'post_status' => 'pending',
	) );
		
	unset( $post_data['post_type'] );
	unset( $post_data['post_status'] );

	foreach ( $sanitized_values as $key => $value ) {
		if ( is_array( $value ) ) {
			$value = array_filter( $value );
			if( ! empty( $value ) ) {
				update_post_meta( $object_id, $key, $value );
			}
		} else {
			update_post_meta( $object_id, $key, $value );
		}
	}

	/**
	 * 将附件附加到新生成的文章ID里
	 */	
	
    if ( !is_admin() ){
		
        $user_id = wp_get_current_user()->ID;
		
        if( get_post_type( $object_id ) == 'case' && $user_id ){ // set 'post', 'page', or your custom posttype

			$file_id = $sanitized_values['video_id'];	
			$author = get_post($file_id)->post_author;//作者
			$file_parent = get_post($file_id)->post_parent;//父级
			
			if(!has_post_thumbnail( $file_id )){ $thumb = get_post_thumbnail_id( $object_id ); } else { $thumb = get_post_thumbnail_id( $file_id );}//video thumbnail image
			
                if ( $author == $user_id && $file_parent == 0){ //附件不能是已存在父id且必须和文章是同一个作者
                    $at_post = array();
                    $at_post['ID'] = $file_id;
                    $at_post['post_parent'] = $object_id; // set post_parent
					$at_post['_thumbnail_id'] = $thumb;
                    wp_update_post( $at_post );
                }

        }
    }
	
	wp_redirect(esc_url_raw( remove_query_arg( array('edit','id','type','step'))));

	exit;	

}
add_action( 'cmb2_after_init', 'chumi_handle_frontend_high_edit_case');

// 处理topic短话题
function chumi_handle_frontend_edit_topic() {

	if ( empty( $_POST ) || ! isset( $_POST['submit-cmb'], $_POST['object_id'] ) ) {
		return false;
	}
	
 	$metabox_id = 'front-end-topic-edit-form';	
	$object_id  = 'fake-id';
	
	$current_url = home_url(add_query_arg(array()));
	$real_id  = substr($current_url,strpos($current_url,'_')+1,strpos($current_url,'.html')-strpos($current_url,'_')-1);
	
	if(isset($_GET['edit']) ) $object_id = $real_id;
	if(isset($_GET['fb'])) unset( $post_data );
	$cmb = cmb2_get_metabox( $metabox_id, $object_id ); 

	$post_data = array();
	
	if ( !isset( $_POST[ $cmb->nonce() ] ) || ! wp_verify_nonce( $_POST[ $cmb->nonce() ], $cmb->nonce() ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'security_fail', __( '未能通过安全检查！' ) ) );
	}	
	
	if ( empty( $_POST['post_title'] ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '请填写标题后再提交！' ) ) );
	}			

	$sanitized_values = $cmb->get_sanitized_values( $_POST );

	$post_data['post_title'] = $sanitized_values['post_title'];
	  unset( $sanitized_values['post_title'] );
	$post_data['tags_input'] = $sanitized_values['submitted_post_tag'];
	  unset( $sanitized_values['submitted_post_tag'] ); 
	  
	$post_data['post_status'] = 'publish';
	$post_data['post_type'] = 'topic';
	$title = mb_strimwidth(strip_tags(Pinyin::getPinyin($post_data['post_title'])), 0, 60,'');

	$cat = intval($sanitized_values['submitted_post_cat']);	
		unset( $sanitized_values['submitted_post_cat'] );
	$exist_cats = get_the_terms($object_id,'topic-types');
	if(empty($cat)) {
		$cat = get_term_by('slug','t-2','topic-types')->term_id;//new:t-2 default
 		if($exist_cats[0]->term_id == 63 ) {
			if(!empty($exist_cats[1]))$cat = $exist_cats[1]->term_id;//edit:max 2 cats
		} else {
			if(!empty($exist_cats[0]))$cat = $exist_cats[0]->term_id;//edit:max 1 cat
		} 
	}

	$img_urls = $sanitized_values['topic_imgurls'];	
		unset( $sanitized_values['topic_imgurls'] );
	foreach($img_urls as $k => $v){
		if(strpos($v,'9cache.com')!== false)$v = substr($v, 0, stripos($v,'_')+1).'700b.jpg';//9gag
		
		if(strpos($v,'sinaimg')==true){ //判断是否新浪图片
		
			$breakurl = substr($v,stripos($v,'.cn/')+4);
			$breakurl2 = substr($breakurl,'0',stripos($breakurl,'/'));
			$largsize = str_replace($breakurl2,'large',$v);
			
			if(preg_match('/.*(\.gif)$/', $v) && isAnimatedGif($v)!==false){
				$gifthumb = str_replace($breakurl2,'small',$v);
				$contents .= '<img src="'.$gifthumb.'" data-gif="'.$v.'"  alt="'.$post_data['post_title'].'" title="'.$post_data['post_title'].'" class="gifs"/>';
				$realgif .= 'yes';
			} else {
				$contents .= '<img src="'.$largsize.'" alt="'.$post_data['post_title'].'" class="topicimg" title="'.$post_data['post_title'].'" />';
			}
			
			$img_urls[$k] = $largsize;
			
		} else {
			if((exif_imagetype($v)==IMAGETYPE_JPEG)||(exif_imagetype($v)==IMAGETYPE_PNG) ) {
				$contents .= '<img src="'.$v.'" alt="'.$post_data['post_title'].'" class="topicimg" title="'.$post_data['post_title'].'" />';
			}
		}		
		
		if((strpos($v,'music.163.com')!==false)||(strpos($v,'xiami.com')!==false)) {//判断是否来自虾米或网易云			
			$contents .= '<p>'.$v.'</p>';	
		} 
	}
	
	if(count($img_urls)>1) {
		$contents = '<div class="multi-images">'.$contents.'<div class="clear"></div></div>';
		if(strpos($post_data['post_title'],']')!==false)$post_data['post_title'] = substr($post_data['post_title'],strpos($post_data['post_title'],']')+1);
		$post_data['post_title'] = '['.count($img_urls).'P]'.$post_data['post_title'];
	}
	if(!empty($sanitized_values['topic_content'])) $topic_content = '<p>'.$sanitized_values['topic_content'].'</p>';
	$contents = $topic_content.''.$contents;//final contents
	
	if(strpos($realgif,'yes')!==false) $cat = array(63,$cat);//自动添加gif类别63	
	
	if(isset($_GET['action']) && $_GET['action']=='new') {
		$new_submission_id = wp_insert_post( array( 
				'post_title'=> $post_data['post_title'],
				'post_content'=> $contents,
				'tags_input'=>$post_data['tags_input'],
				'post_type' => 'topic',
				'post_status' => 'pending',
		) );
 		wp_update_post( array( 
			'ID' => $new_submission_id,
			'post_name'=> substr(md5($title), 0, 15).'_'.$new_submission_id,
		) ); 
 	} elseif(isset($_GET['action']) && $_GET['action']=='child') {
		$new_submission_id = wp_insert_post( array( 
				'post_title'=> $post_data['post_title'],
				'post_content'=> $contents,
				'tags_input'=>$post_data['tags_input'],
				'post_type' => 'topic' ,
				'post_status' => 'pending',
				'post_parent' => $real_id,
		) );
 		wp_update_post( array( 
			'ID' => $new_submission_id,
			'post_name'=> substr(md5($title), 0, 15).'_'.$new_submission_id,
		) );
	} else {
		wp_update_post( array( 
			'ID' => $object_id,
			'post_title'=> $post_data['post_title'],
			'post_content'=> $contents,
			'tags_input'=>$post_data['tags_input'],
			'post_name'=> substr(md5($title), 0, 15).'_'.$object_id,			
		) );
		$new_submission_id = $object_id;
	} 

	wp_set_object_terms( $new_submission_id, $cat, 'topic-types');
	
	foreach($img_urls as $img_url){
		$orimg = '';
		if(strpos($img_url,'douhua.')== false){ //判断是否本地图片
			if(strpos($img_url,'9cache.com')!== false){
				$orimg = $img_url;
				$img_url = substr($img_url, 0, stripos($img_url,'_')+1).'700b.jpg';//9gag
			}
			if((exif_imagetype($img_url)==IMAGETYPE_JPEG)||(exif_imagetype($img_url)==IMAGETYPE_PNG) ){
				$img_id = get_media_downloader($new_submission_id,$img_url,'topic');
				if(!empty($orimg))//9gag
					wp_update_post( array( 'ID' => $img_id,'post_title'=> $orimg) );
			}
		}
	}

	$newimages = get_attached_media( 'image', $new_submission_id);
	if(count($newimages) !== 0) {
		foreach($newimages as $newimg){
			foreach($img_urls as $k => $v) {
				if($v === $newimg->post_title)$img_urls[$k] = wp_get_attachment_url( $newimg->ID ); 
			}			
			if(stripos($contents,$newimg->post_title)!== false){//判断地址是否被包含，如果是则替换
				if(stripos($newimg->post_title, 'http') !== false )$contents = str_replace($newimg->post_title,wp_get_attachment_url( $newimg->ID ),$contents);//如果title是url的话就进行替换；
				wp_update_post(array('ID'=>$newimg->ID,'post_title'=>$post_data['post_title']));
			}
		}
		wp_update_post(array('ID'=>$new_submission_id,'post_content'=>$contents));
	}
	
	update_post_meta( $new_submission_id, 'topic_imgurls', $img_urls );
	
	if ( is_wp_error( $new_submission_id ) ) {
		return $cmb->prop( 'submission_error', $new_submission_id );
	}
	
	foreach ( $sanitized_values as $key => $value ) {
		if ( is_array( $value ) ) {
			$value = array_filter( $value );
			if( ! empty( $value ) ) {
				update_post_meta( $new_submission_id, $key, $value );
			}
		} else {
				update_post_meta( $new_submission_id, $key, $value );
		}
	}
	//topic_content 如果之前有内容后来删除 也就是值为空的情况会导致数据不更新
	if(empty($sanitized_values['topic_content']))delete_post_meta( $new_submission_id, 'topic_content');
	
	wp_redirect(home_url(). '/?p='.$new_submission_id);	
	
	exit;
}
add_action( 'cmb2_after_init', 'chumi_handle_frontend_edit_topic' );


function isAnimatedGif($filename) {
    $fp = fopen($filename, 'rb');
    $filecontent = fread($fp, filesize($filename));
    fclose($fp);
    return strpos($filecontent, chr(0x21) . chr(0xff) . chr(0x0b) . 'NETSCAPE2.0') === FALSE ? 0 : 1;
}

/**
 * Handles form submission on save. Redirects if save is successful, otherwise sets an error message as a cmb property
 */
function chumi_handle_frontend_edit_download() {

	if ( empty( $_POST ) || ! isset( $_POST['submit-cmb'], $_POST['object_id'] ) ) {
		return false;
	}
	$metabox_id = 'front-end-download-edit-form';	
	$current_url = home_url(add_query_arg(array()));	
	$object_id  = substr($current_url,strpos($current_url,'_')+1,strpos($current_url,'.html')-strpos($current_url,'_')-1);

	$cmb = cmb2_get_metabox( $metabox_id, $object_id );

	$post_data = array();

	if ( isset( $_POST['atts'] ) ) {
		foreach ( (array) $_POST['atts'] as $key => $value ) {
			$post_data[ $key ] = sanitize_text_field( $value );
		}
		//unset( $_POST['atts'] );如果 不注释掉会导致前端表格的cpt等失效
	}

	if ( ! isset( $_POST[ $cmb->nonce() ] ) || ! wp_verify_nonce( $_POST[ $cmb->nonce() ], $cmb->nonce() ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'security_fail', __( '未能通过安全检查！' ) ) );
	}

	if ( empty( $_POST['post_title'] ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '请在标题框中输入标题！' ) ) );
	}
	
	if ( empty( $_POST['post_content'] ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '请填写文章内容后再提交' ) ) );
	}		

	if ( $cmb->get_field( 'post_title' )->default() == $_POST['post_title'] ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '重复！请输入一个新标题。' ) ) );
	}		

	$sanitized_values = $cmb->get_sanitized_values( $_POST );

	$post_data['post_title']   = $sanitized_values['post_title'];
	unset( $sanitized_values['post_title'] );
	$post_data['post_content'] = $sanitized_values['post_content'];
	unset( $sanitized_values['post_content'] );	
	$post_data['tags_input'] = $sanitized_values['submitted_post_tag'];
	unset( $sanitized_values['submitted_post_tag'] );
	$title = mb_strimwidth(strip_tags(Pinyin::getPinyin($post_data['post_title'])), 0, 60,'');

	wp_update_post( array( 
		'ID' => $object_id,
		'post_title'=> $post_data['post_title'],
		'post_content'=>$post_data['post_content'],
		'tags_input'=>$post_data['tags_input'],
		'post_name'=> substr(md5($title), 0, 15).'_'.$object_id,
	) );

	if ( is_wp_error( $object_id ) ) {
		return $cmb->prop( 'submission_error', $object_id );
	}
		
	unset( $post_data['post_type'] );
	unset( $post_data['post_status'] );

	foreach ( $sanitized_values as $key => $value ) {
		if ( is_array( $value ) ) {
			$value = array_filter( $value );
			if( ! empty( $value ) ) {
				update_post_meta( $object_id, $key, $value );
			}
		} else {
			update_post_meta( $object_id, $key, $value );
		}
	}	
	
	wp_redirect(esc_url_raw( remove_query_arg( array('edit','id','type'))));
	exit;	

}
add_action( 'cmb2_after_init', 'chumi_handle_frontend_edit_download' );