<?php

function cmb2_output_file_list( $file_list_meta_key) {

    // Get the list of files
    $files = get_post_meta( get_the_ID(), $file_list_meta_key, 1 );

    echo '<ul class="cmb-attach-list">';
    foreach ( (array) $files as $attachment_id => $attachment_url ) {
		
		$filetype = wp_check_filetype($attachment_url)['ext'];
		if(empty($filetype))$filetype = '未知类型';
		$file_size = filesize( get_attached_file( $attachment_id ) )/1024/1024;
		$name = get_post($attachment_id)->post_title;
		if(empty($name)) { $name = '文件丢失或已损坏！';}

		echo '<li class="file-list-attachment">';
		echo '<span class="ext">'.$filetype.'</span>';
		echo '<span class="size">'.sprintf("%.2f", $file_size).'mb</span>';		
		echo '<span>'.$name.'</span>';
		echo '<a href="'.$attachment_url.'" class="downlink right">下载</a>';
        echo '</li>';
    }
    echo '</ul>';
}

function cmb2_output_image_list( $file_list_meta_key) {

    // Get the list of files
    $files = get_post_meta( get_the_ID(), $file_list_meta_key, 1 );
	
	$unshow = get_post_meta(get_the_ID(),'unShowPoster',true);
	if(empty($unshow)) $unshow='';		

    echo '<ul class="cmb-image-list">';
    foreach ( (array) $files as $attachment_id => $attachment_url ) {
		
		$filetype = wp_check_filetype($attachment_url)['ext'];
		if(empty($filetype))$filetype = '未知类型';
		$name = get_post($attachment_id)->post_title;
		if(empty($name)) { $name = '文件丢失或已损坏！';}
		
		$exts= array('jpg','jpeg','png','gif','bmp');
		
		if(in_array($filetype,$exts)) {
			
			if( !($unshow =='on' && $attachment_id == get_post_thumbnail_id())) {
				echo '<p class="image-list-attachment">';
				echo '<img src="'.$attachment_url.'" alt="'.$name.'">';
				echo '</p>';								
			}
		}
    }
    echo '</ul>';
}

/**
 * slider 4 single case iamges mobile
 * 结构跟上面的相同
 */
function sve_mobile_output_image_list( $file_list_meta_key ) {

    // Get the list of files
    $files = get_post_meta( get_the_ID(), $file_list_meta_key, 1 );
	
	$unshow = get_post_meta(get_the_ID(),'unShowPoster',true);
	if(empty($unshow)) $unshow='';		

    foreach ( (array) $files as $attachment_id => $attachment_url ) {
		
		$filetype = wp_check_filetype($attachment_url)['ext'];
		if(empty($filetype))$filetype = '未知类型';
		$name = get_post($attachment_id)->post_title;
		if(empty($name)) { $name = '文件丢失或已损坏！';}
		
		$exts= array('jpg','jpeg','png','gif','bmp');
		
		if(in_array($filetype,$exts)) {
			
			if( !($unshow =='on' && $attachment_id == get_post_thumbnail_id())) {
				echo '<div>';
				echo '<div class="overlay"></div>';
				echo '<img src="'.$attachment_url.'" alt="img" class="responsive-image">';	
				echo '</div>';
			}
		}
    }
}

/**
 * slider 4 single case iamges PC
 * 结构跟上面的相同
 */
function sve_case_output_image_list( $file_list_meta_key,$width,$height,$pattern ) {

    $postid = get_the_ID();
    $files = get_post_meta( $postid, $file_list_meta_key, 1 );
	$unshow = get_post_meta($postid,'unShowPoster',true);
	if(empty($unshow)) $unshow='';
	
	echo '<div id="'.$pattern.'" class="owl-carousel" style="width:'.$width.'px;">';

    foreach ( (array) $files as $attachment_id => $attachment_url ) {
		
		$filetype = wp_check_filetype($attachment_url)['ext'];
		if(empty($filetype))$filetype = '未知类型';
		$name = get_post($attachment_id)->post_title;
		if(empty($name)) { $name = '文件丢失或已损坏！';}
		
		$exts= array('jpg','jpeg','png','gif','bmp');
		
		if(in_array($filetype,$exts)) {
			
			if( !($unshow =='on' && $attachment_id == get_post_thumbnail_id())) {
				echo '<a class="item">';
				echo '<img src="'.$attachment_url.'" width="'.$width.'" alt="'.get_the_title($postid).'">';	
				echo '</a>';
			}
		}
    } 
	echo '</div><div class="clear"></div>';
	
	$styles = get_post_meta( $postid, 'showSlider', 1 );
	if($styles):
	if(in_array('autoslide', array_values($styles))) $sets ='autoPlay:true,';
	if(in_array('pagination', array_values($styles))) $sets .='pagination:false,';
	if(in_array('autosize', array_values($styles))) $sets .='autoHeight:true,';
	if(in_array('progressbar', array_values($styles))) $barfunc ='afterInit: progressBar, afterMove: moved, startDragging: pauseOnDragging';
	if(!in_array('unshowslide', array_values($styles))) {
?>
<script type="text/javascript">
	$(function(){
		
    var time = 5;
    var $progressBar, $bar, $elem, isPause, tick, percentTime;
 
    $('#<?php echo $pattern;?>').owlCarousel({
		items: 1,
		<?php echo $sets;?>
        slideSpeed: 500,
        paginationSpeed: 500,
        singleItem: true,
		<?php echo $barfunc;?>
    });
 
    function progressBar(elem){
        $elem = elem;
        buildProgressBar();
        start();
    }
 
    function buildProgressBar(){
        $progressBar = $('<div>',{
            id:'progressBar'
        });
        $bar = $('<div>',{
            id:'bar'
        });
        $progressBar.append($bar).insertAfter($elem.children().eq(0));
    }
 
    function start(){
        percentTime = 0;
        isPause = false;
        tick = setInterval(interval, 10);
    }
 
    function interval(){
        if(isPause === false){
            percentTime += 1 / time;
            $bar.css({
                width: percentTime+'%'
            });
            if(percentTime >= 100){
                $elem.trigger('owl.next')
            }
        }
    }
 
    function pauseOnDragging(){
        isPause = true;
    }
 
    function moved(){
        clearTimeout(tick);
        start();
    }
 
    $elem.on('mouseover',function(){
        isPause = true;
    })
 
    $elem.on('mouseout',function(){
        isPause = false;
    });
});
</script>
<?php

	}
	endif;
}

function video_frontend_cmb2_get() {

	$metabox_id = 'front-end-video-form';
	
	$object_id  = 'fake-object-id';		

	return cmb2_get_metabox( $metabox_id, $object_id );
}

function video_frontend_form_submission_shortcode( $atts = array() ) {
	
	if ( ! current_user_can( 'read' ) || !is_user_logged_in() ) {
		return __( '对不起！您没有权限浏览该页面 >_< ', '' );
	}
	
	$cmb = video_frontend_cmb2_get();

	$post_types = $cmb->prop( 'object_types' );
	
	$user_id = get_current_user_id();

	$atts = shortcode_atts( array(
		'post_author' => $user_id ? $user_id : 1, // Current user, or admin
		'post_status' => 'draft',
		'post_type'   => reset( $post_types), // Only use first object_type in array
	), $atts, 'cmb-video-frontend-form' );

	/*
	 * Let's add these attributes as hidden fields to our cmb form
	 * so that they will be passed through to our form submission
	 */
	foreach ( $atts as $key => $value ) {
		$cmb->add_hidden_field( array(
			'field_args'  => array(
				'id'    => "atts[$key]",
				'type'  => 'hidden',
				'default' => $value,
			),
		) );
	}

	// Initiate our output variable
	$output = '';

	// Get any submission errors
	if ( ( $error = $cmb->prop( 'submission_error' ) ) && is_wp_error( $error ) ) {
		// If there was an error with the submission, add it to our ouput.
		$output .= '<h3>' . sprintf( __( '提交出错: %s', '' ), '<strong>'. $error->get_error_message() .'</strong>' ) . '</h3>';
	}
	

	$output .= cmb2_get_metabox_form( $cmb,'fake-object-id', array( 'save_button' => __( '保存', 'chumi' ) ) );

	return $output;

}
add_shortcode( 'cmb-video-frontend-form', 'video_frontend_form_submission_shortcode' );


function chumi_handle_frontend_new_video_form_submission() {

	// If no form submission, bail
	if ( empty( $_POST ) || ! isset( $_POST['submit-cmb'], $_POST['object_id'] ) ) {
		return false;
	}

	// Get CMB2 metabox object
	$cmb = video_frontend_cmb2_get();

	$post_data = array();

	// Get our shortcode attributes and set them as our initial post_data args
	if ( isset( $_POST['atts'] ) ) {
		foreach ( (array) $_POST['atts'] as $key => $value ) {
			$post_data[ $key ] = sanitize_text_field( $value );
		}
		//unset( $_POST['atts'] );
	}

	if ( ! isset( $_POST[ $cmb->nonce() ] ) || ! wp_verify_nonce( $_POST[ $cmb->nonce() ], $cmb->nonce() ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'security_fail', __( '未能通过安全检查！' ) ) );
	}

	if ( empty( $_POST['submitted_post_title'] ) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '请在标题框中输入标题！' ) ) );
	}
	
	if ( empty( $_POST['fake_video'] ) && empty($_POST['video_id']) && empty($_POST['wechat_videouri']) && empty($_POST['videouri']) ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '请添加视频链接或文件！' ) ) );
	}

	if ( $cmb->get_field( 'submitted_post_title' )->default() == $_POST['submitted_post_title'] ) {
		return $cmb->prop( 'submission_error', new WP_Error( 'post_data_missing', __( '重复！请输入一个新标题。' ) ) );
	}	

	$sanitized_values = $cmb->get_sanitized_values( $_POST );

	$post_data['post_title']   = $sanitized_values['submitted_post_title'];
	unset( $sanitized_values['submitted_post_title'] );
	if ( !empty( $_POST['post_content'] ) ) {
		$post_data['post_content'] = $sanitized_values['post_content'];
	}
	unset( $sanitized_values['post_content'] );	
	$post_data['tags_input'] = $sanitized_values['submitted_post_tag'];
	unset( $sanitized_values['submitted_post_tag'] );
	
	$fake_video_url = $sanitized_values['fake_video'];
	unset( $sanitized_values['fake_video'] );
	
	// Create the new post
	
	$new_video_id = wp_insert_post( $post_data, true );	
	wp_set_object_terms( $new_video_id, $category, 'category');
	$title = mb_strimwidth(strip_tags(Pinyin::getPinyin($post_data['post_title'])), 0, 60,'');
	wp_update_post( array( 'ID' => $new_video_id,'post_name'  =>substr(md5($title), 0, 15).'_'.$new_video_id) );
		update_post_meta( $new_video_id, 'videws', '1' );
	
	//生成视频源id字段-bilibili
	$aid_url=$sanitized_values['videouri'];
	if(empty($aid_url)) $aid_url=$sanitized_values['wechat_videouri'];
	if(strpos($aid_url,'bilibili.com') > 0 || strpos($aid_url,'hdslb.com') > 0 ) {
		if(strpos($aid_url,'av') > 0 && strpos($aid_url,'?') > 0) $aid = substr($aid_url,strpos($aid_url,'av')+2,strpos($aid_url,'?')-strpos($aid_url,'av')-3);
		if(strpos($aid_url,'av') > 0 &&  strpos($aid_url,"?") < 1) {$aid = substr($aid_url,strpos($aid_url,"av")+2);$aid = substr($aid,0,strpos($aid,"/"));}
		if(strpos($aid_url,'aid') > 0) $aid = substr($aid_url,strpos($aid,"aid")+3);
		
		update_post_meta( $new_video_id, 'bilibili_aid', $aid );
	}
	//生成视频源id字段-tencent
	if(strpos($aid_url,'qq.com') > 0 && strpos($aid_url,'html') > 0) {
		$vid=substr($aid_url,strpos($aid_url,'html')-12,11);	
		update_post_meta( $new_video_id, 'qq_vid', $vid );
	}	

	$cat = $sanitized_values['submitted_post_cat'];	
	unset( $sanitized_values['submitted_post_cat'] );
	$category = intval($cat);
	if(empty($category)) {
		$category = get_term_by('slug','t-2','topic-types')->term_id;//new:t-2 default
	}
	wp_set_object_terms( $new_video_id, $category, 'topic-types');		
	
	if ( is_wp_error( $new_video_id ) ) {
		return $cmb->prop( 'submission_error', $new_video_id );
	}

	foreach ( $sanitized_values as $key => $value ) {
		if ( is_array( $value ) ) {
			$value = array_filter( $value );
			if( ! empty( $value ) ) {
				update_post_meta( $new_video_id, $key, $value );
			}
		} else {
			update_post_meta( $new_video_id, $key, $value );
		}
	}
	
	$votecounts = rand(1,3);//随机点赞数
	update_post_meta($new_video_id,'vote-up_count',$votecounts);
	if(strpos($fake_video_url,'.mp4') !== false){
	
			$newvideo = get_media_downloader($new_video_id,$fake_video_url,'video');//upload
			$newvideo_link = wp_get_attachment_url( $newvideo );	

			update_post_meta( $new_video_id,'video_id', $newvideo );
			update_post_meta( $new_video_id,'video', $newvideo_link );  
	}

	if(strpos($fake_video_url,'.webm') !== false){

			if(strpos($fake_video_url,'9cache.com') !== false ){//9gag
				$fake_video_url = str_replace('vp9.webm','.mp4',$fake_video_url);
			} else {
				$fake_video_url = false;//定义为false
			}
			
			if($fake_video_url !== false){
				$newvideo = get_media_downloader($new_video_id,$fake_video_url,'video');//upload
				$newvideo_link = wp_get_attachment_url( $newvideo );	

				update_post_meta( $new_video_id,'video_id', $newvideo );
				update_post_meta( $new_video_id,'video', $newvideo_link );
			}
	}	
	
	/**
	 * 将附件附加到新生成的文章ID里
	 * our uploaded attachment post to have the same post-data
	 */	
	
    if ( !is_admin() ){
		
        $user_id = wp_get_current_user()->ID;
		
        if( get_post_type( $new_video_id ) == 'video' && $user_id ){ // set "post", "page", or your custom posttype

			$file_id = $sanitized_values['video_id'];	
			$author = get_post($file_id)->post_author;//作者
			$file_parent = get_post($file_id)->post_parent;//父级
				
                if ( $author == $user_id && $file_parent == 0){
                    $at_post = array();
                    $at_post['ID'] = $file_id;
                    $at_post['post_parent'] = $new_video_id; // set post_parent
                    wp_update_post( $at_post );
                }

        }
    }
	
	$videoid = get_post_meta($new_video_id,'video_id',true);//挂载的视频id
	if(!empty($videoid) ){
		$thumbnail_id = get_post_thumbnail_id( $videoid );
		wp_update_post( array( 
			'ID' => $videoid,
			'post_title'=> $post_data['post_title'],
		) );
		update_post_meta( $new_video_id, 'video_thumbnail_id', $thumbnail_id );
		update_post_meta( $new_video_id, 'video_thumbnail', wp_get_attachment_image_src( $thumbnail_id,full)[0] );

		if(has_post_thumbnail($new_video_id) == false)
			wp_update_post( array('ID' =>  $new_video_id,'_thumbnail_id' => $thumbnail_id) );
	}	
	
	wp_redirect(home_url(). '/?p='.$new_video_id.'&step=1');
	
	exit;	

}

add_action( 'cmb2_after_init', 'chumi_handle_frontend_new_video_form_submission' );