<?php

date_default_timezone_set('Asia/Shanghai'); //声明时区

//Disable the emoji's
function disable_emojis() {
	remove_action( 'wp_head', 'print_emoji_detection_script', 7 );
	remove_action( 'admin_print_scripts', 'print_emoji_detection_script' );
	remove_action( 'wp_print_styles', 'print_emoji_styles' );
	remove_action( 'admin_print_styles', 'print_emoji_styles' );
	remove_filter( 'the_content_feed', 'wp_staticize_emoji' );
	remove_filter( 'comment_text_rss', 'wp_staticize_emoji' );
	remove_filter( 'wp_mail', 'wp_staticize_emoji_for_email' );
	add_filter( 'tiny_mce_plugins', 'disable_emojis_tinymce' );
 }
add_action( 'init', 'disable_emojis' );

//禁止WordPress头部加载s.w.org
add_filter( 'emoji_svg_url', '__return_false' );

//Filter function used to remove the tinymce emoji plugin.
function disable_emojis_tinymce( $plugins ) {
	if ( is_array( $plugins ) ) {
			return array_diff( $plugins, array( 'wpemoji' ) );
		} else {
		return array();
		}
}

//禁用REST API/移除wp-json链接的方法
add_filter('rest_enabled', '__return_false');
add_filter('rest_jsonp_enabled', '__return_false');
remove_action( 'wp_head', 'rest_output_link_wp_head', 10 );
remove_action( 'wp_head', 'wp_oembed_add_discovery_links', 10 );

//优化wordpress头部信息
remove_action( 'wp_head', 'feed_links', 2 ); //移除feed
remove_action( 'wp_head', 'feed_links_extra', 3 ); //移除feed
remove_action( 'wp_head', 'rsd_link' ); //移除离线编辑器开放接口
remove_action( 'wp_head', 'wlwmanifest_link' );  //移除离线编辑器开放接口
remove_action( 'wp_head', 'index_rel_link' );//去除本页唯一链接信息
remove_action('wp_head', 'parent_post_rel_link', 10, 0 );//清除前后文信息
remove_action('wp_head', 'start_post_rel_link', 10, 0 );//清除前后文信息
remove_action( 'wp_head', 'adjacent_posts_rel_link_wp_head', 10, 0 );
remove_action( 'wp_head', 'locale_stylesheet' );
remove_action('publish_future_post','check_and_publish_future_post',10, 1 );
remove_action( 'wp_head', 'noindex', 1 );
remove_action( 'wp_head', 'wp_print_styles', 8 );//载入css
remove_action( 'wp_head', 'wp_generator' ); //移除WordPress版本
remove_action( 'wp_head', 'rel_canonical' );
remove_action( 'wp_head', 'wp_shortlink_wp_head', 10, 0 );
remove_action( 'template_redirect', 'wp_shortlink_header', 11, 0 );
add_action('widgets_init', 'chumi_remove_recent_comments_style');
function chumi_remove_recent_comments_style() {
	global $wp_widget_factory;
	remove_action('wp_head', array($wp_widget_factory->widgets['WP_Widget_Recent_Comments'] ,'recent_comments_style'));
}

//禁用embeds
function disable_embeds_init() {
    /* @var WP $wp */
    global $wp;
 
    $wp->public_query_vars = array_diff( $wp->public_query_vars, array(
        'embed',
    ) );
 
    remove_action( 'rest_api_init', 'wp_oembed_register_route' );
 
    add_filter( 'embed_oembed_discover', '__return_false' );
 
    remove_filter( 'oembed_dataparse', 'wp_filter_oembed_result', 10 );
 
    remove_action( 'wp_head', 'wp_oembed_add_discovery_links' );
 
    remove_action( 'wp_head', 'wp_oembed_add_host_js' );
    add_filter( 'tiny_mce_plugins', 'disable_embeds_tiny_mce_plugin' );
 
    add_filter( 'rewrite_rules_array', 'disable_embeds_rewrites' );
}
 
add_action( 'init', 'disable_embeds_init', 9999 );

//Removes the 'wpembed' TinyMCE plugin.
function disable_embeds_tiny_mce_plugin( $plugins ) {
    return array_diff( $plugins, array( 'wpembed' ) );
}
 
// Remove all rewrite rules related to embeds.
function disable_embeds_rewrites( $rules ) {
    foreach ( $rules as $rule => $rewrite ) {
        if ( false !== strpos( $rewrite, 'embed=true' ) ) {
            unset( $rules[ $rule ] );
        }
    }
    return $rules;
}
 
//Remove embeds rewrite rules on plugin activation.
function disable_embeds_remove_rewrite_rules() {
    add_filter( 'rewrite_rules_array', 'disable_embeds_rewrites' );
    flush_rewrite_rules();
}
register_activation_hook( __FILE__, 'disable_embeds_remove_rewrite_rules' );
 
//Flush rewrite rules on plugin deactivation.
function disable_embeds_flush_rewrite_rules() {
    remove_filter( 'rewrite_rules_array', 'disable_embeds_rewrites' );
    flush_rewrite_rules();
}
 
register_deactivation_hook( __FILE__, 'disable_embeds_flush_rewrite_rules' );

//禁用谷歌字体
defined('ABSPATH') or exit;
function coolwp_remove_open_sans_from_wp_core() {
    wp_deregister_style( 'open-sans' );
    wp_register_style( 'open-sans', false );
    wp_enqueue_style('open-sans','');
}
add_action( 'init', 'coolwp_remove_open_sans_from_wp_core' );

//禁用open_sans
add_filter( 'gettext_with_context', 'bno_disable_open_sans', 888, 4 );
function bno_disable_open_sans( $translations, $text, $context, $domain ) {
    if ( 'Open Sans font: on or off' == $context && 'on' == $text ) {
        $translations = 'off';
    }
    return $translations;
}

//Set the left pannel style of dashboard.
add_action('admin_head', 'bno_admin_style');
function bno_admin_style() {
    echo '<link rel="stylesheet" href="' . get_template_directory_uri() . '/css/admin_style.css" type="text/css" media="all" />';
    echo '<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=0" />';
    echo '<meta name="apple-mobile-web-app-capable" content="yes">';
} 
 
//Retranslate some words.
add_filter(  'gettext',  'wps_translate_words_array'  );
add_filter(  'ngettext',  'wps_translate_words_array'  );
function wps_translate_words_array( $translated ) {	   
	$words = array(		
		'状态' => '操作',
		'图像描述' => '描述',
		'插入至文章' => '插入到编辑器',
		'或链接到站点中的内容' => '或链接到站点中的内容(请至少输入三个字符)',
	);
    $translated = str_ireplace(  array_keys($words),  $words,  $translated );	
    return $translated;
}

/**
 * Disable some metaboxes in featured post type.
 * @since BlueRed 1.0
 */
add_action('do_meta_boxes', 'bno_move_meta_box');
function bno_move_meta_box(){
	$types= array('post','page','specialist','download' ,'course','reading');
	foreach ($types as $type) {
        remove_meta_box( 'postexcerpt', $type, 'normal' );
        remove_meta_box( 'trackbacksdiv', $type, 'normal' );
        remove_meta_box( 'postcustom', $type, 'normal' );
        //remove_meta_box( 'commentstatusdiv', $type, 'normal' );会导致文章评论被关闭，可采用css来隐藏
        remove_meta_box( 'commentsdiv', $type, 'normal' );
        remove_meta_box( 'revisionsdiv', $type, 'normal' );
        remove_meta_box( 'authordiv', $type, 'normal' );
        remove_meta_box( 'slugdiv', $type, 'normal' );
        remove_meta_box( 'wpuf-select-form', $type, 'side' );
        remove_meta_box( 'wpuf-custom-fields', $type, 'normal' );
        remove_meta_box( 'formatdiv', $type, 'side' );
   		remove_meta_box( 'postimagediv', $type, 'side' );
  	  	add_meta_box('postimagediv', __('设置封面图片'), 'post_thumbnail_meta_box', $type, 'side');	
	}	
	   	remove_meta_box( 'postimagediv', 'team', 'side' );
  	  	add_meta_box('postimagediv', __('上传人物照片'), 'post_thumbnail_meta_box', 'team', 'side');	
}

/**
 * Disable the top pannel and some other left pannel items.
 * @since BlueRed 1.0
 */
show_admin_bar(false);
function remove_admin_bar_links() {
    global $wp_admin_bar;
    $wp_admin_bar->remove_menu('wp-logo');          // Remove the WordPress logo
    $wp_admin_bar->remove_menu('about');            // Remove the about WordPress link
    $wp_admin_bar->remove_menu('wporg');            // Remove the WordPress.org link
    $wp_admin_bar->remove_menu('documentation');    // Remove the WordPress documentation link
    $wp_admin_bar->remove_menu('support-forums');   // Remove the support forums link
    $wp_admin_bar->remove_menu('feedback');         // Remove the feedback link
    $wp_admin_bar->remove_menu('site-name');        // Remove the site name menu
    $wp_admin_bar->remove_menu('view-site');        // Remove the view site link
    $wp_admin_bar->remove_menu('updates');          // Remove the updates link
    $wp_admin_bar->remove_menu('comments');         // Remove the comments link
    $wp_admin_bar->remove_menu('new-content');      // Remove the content link
    $wp_admin_bar->remove_menu('w3tc');             // If you use w3 total cache remove the performance link

}
add_action( 'wp_before_admin_bar_render', 'remove_admin_bar_links' );

/**
 * Change the Dashboard name to a new one.
 * @since BlueRed 1.0
 */
function bno_top_site_name($wp_admin_bar){
	$args = array(
		'id' => 'top-site-name',
		'title' => '控制台',
		'href' => get_home_url(),
		'meta' => array('class' => 'custom-button-class')
	);
	$wp_admin_bar->add_node($args);
}
add_action('admin_bar_menu', 'bno_top_site_name', 50);

//Set the title of dashboard.
add_action('admin_menu', 'bno_admin_menu');
function bno_admin_menu() {
    global $menu;
    $url = get_home_url();
    $menu[0] = array( __('控制台'), 'read', $url, 'bno-logo', 'bno-logo');
}


//log-in failed.
add_action( 'wp_login_failed', 'dh_front_end_login_fail' );  // hook failed login
function dh_front_end_login_fail( $username ) {
   $referrer = $_SERVER['HTTP_REFERER'];  // where did the post submission come from?
   if ( !empty($referrer) && !strstr($referrer,'wp-login') && !strstr($referrer,'wp-admin') ) {
	   
	   $tail=$referrer.'?login=failed';//diffrent tail
	   if(strpos($referrer,'path=') !== false)$tail=$referrer.'&login=failed';
	   
      wp_redirect( $tail ); 
      exit;
   }
}

//use chinese register
function bno_non_strict_login( $username, $raw_username, $strict ) {
	if( !$strict )
	return $username;
	return sanitize_user(stripslashes($raw_username), false);
}
add_filter('sanitize_user', 'bno_non_strict_login', 10, 3);


//自定义表情：
/* add_filter('smilies_src', 'bno_smilies_src', 10, 3);
function bno_smilies_src($img_src, $img, $siteurl) {
   return $siteurl.'/wp-content/images/smilies/'.$img;
} */
 
 function bno_get_wpsmiliestrans() {
    global $wpsmiliestrans;
    $wpsmilies = array_unique($wpsmiliestrans);
    $output = '';
    foreach ($wpsmilies as $alt => $src_path) {
        $output .= '<a data-action="addSmily" data-smilies="' . $alt . '">'.$src_path.'</a>';
    }
    return $output;
}
 
function bno_smilies_reset() {
    global $wpsmiliestrans, $wp_smiliessearch;
    if ( !get_option( 'use_smilies' ) )
        return;
 
    $wpsmiliestrans = array(
		':)' => '<img class="wp-smiley" src="' . get_template_directory_uri() . '/images/smilies/icon_smile.svg"/>',
        ':(' => '<img class="wp-smiley" src="' . get_template_directory_uri() . '/images/smilies/icon_sad.svg"/>',
        ':cry:' => '<img class="wp-smiley" src="' . get_template_directory_uri() . '/images/smilies/icon_cry.svg"/>',
        ':D' => '<img class="wp-smiley" src="' . get_template_directory_uri() . '/images/smilies/icon_grin.svg"/>',
        ':razz:' => '<img class="wp-smiley" src="' . get_template_directory_uri() . '/images/smilies/icon_razz.svg"/>',
        ':o' => '<img class="wp-smiley" src="' . get_template_directory_uri() . '/images/smilies/icon_shock.svg"/>',
        ':x' => '<img class="wp-smiley" src="' . get_template_directory_uri() . '/images/smilies/icon_mad.svg"/>',
        ':lol:' => '<img class="wp-smiley" src="' . get_template_directory_uri() . '/images/smilies/icon_crying.svg"/>',
        ';)' => '<img class="wp-smiley" src="' . get_template_directory_uri() . '/images/smilies/icon_laughs.svg"/>',
		'8-)' => '<img class="wp-smiley" src="' . get_template_directory_uri() . '/images/smilies/icon_love.svg"/>',
		'8O' => '<img class="wp-smiley" src="' . get_template_directory_uri() . '/images/smilies/icon_nerd.svg"/>',
		':|' => '<img class="wp-smiley" src="' . get_template_directory_uri() . '/images/smilies/icon_sleeping.svg"/>',
		':cool:' => '<img class="wp-smiley" src="' . get_template_directory_uri() . '/images/smilies/icon_cool.svg"/>',
    );
}
add_action('init','bno_smilies_reset'); 